/***************************************************************************
 *
 * QWIX - QWK mail packet reader Version 2.0
 * 
 * Copyright:	Dave MacRae 1992
 *
 * This source code may be freely distributed on the condition that is 
 * distributed in its entirety and that this notice is included. and that
 * no charge is made for this distribution, except for possible media costs.
 *
 ***************************************************************************
 */
static char sccsid[] = "@(#) header.c 2.1 1/22/92 12:13:45";
#include "qwix.h"

static int index_fd;
static char index_file[80];
struct header_list *header_list[MAX_HEADER];

long nohead;

extern int message_fd;

open_index (conference) 
int conference;
{

    sprintf(index_file, "%s/%03d.ndx", QWK_FILES, conference);
    if ((index_fd = open(index_file, O_RDONLY)) < 0) {
	perror("Error on open of index file");
	return (-1);
    }

    return 0;
}

close_conference ()
{
    register i;
    for (i = 0;i < nohead;i++)
	free(header_list[i]);
    nohead = 0;
    close (index_fd);
}

get_index ()
{
    char x;
    long Expon, Temp;
    long index;

    switch (read (index_fd, &index, 4)) {
	case 4:  break;
	case 0:  return (0);
	default: return (-1);
    }

    read (index_fd, &x, 1);

    lswap(&index);
    Expon = index >> 24;
    Expon &= 0xff;
    index = index & 0x007fffff;
    index |= 0x00800000;
    Expon -= 152;
    if (Expon < 0)
	index >>= abs(Expon);
    else
	index <<= Expon;
 
    return index;
}


read_header (conf_num) 
int conf_num;
{

    long message_index;

    open_index(conf_num);

    message_index = get_index();

    while (message_index > 0) {
	add_header (message_index);
	message_index = get_index();
    }

}

add_header (message_index) 
long message_index;
{
    struct header head;

    message_index--;
    lseek(message_fd, message_index * RECSIZE, 0);

    header_list[nohead] = (struct header_list *) malloc(sizeof(struct header_list));
    if (header_list[nohead] == (struct header_list *) 0) {
	printf("memory allocation error\n");
	fflush(stdout);
    }
    header_list[nohead]->index = message_index;

    if (read(message_fd, &head, RECSIZE) == -1)
    	return(0);

    memcpy(&header_list[nohead]->header, &head, RECSIZE);
    nohead++;
}


display_header (NoHead)
int NoHead;
{
    int i;
    char tmp[32];

    memcpy(tmp, header_list[NoHead]->header.number, NUMBERSIZE);
    tmp[NUMBERSIZE] = NULL;
    printf("%-6d", atol(tmp));

    memcpy(tmp, header_list[NoHead]->header.to, TOSIZE);
    tmp[TOSIZE] = NULL;
    printf("TO: %25s\t", tmp);

    memcpy(tmp, header_list[NoHead]->header.from, FROMSIZE);
    tmp[FROMSIZE] = NULL;
    printf("From: %25s\n", tmp);

    memcpy(tmp, header_list[NoHead]->header.subject, SUBJECTSIZE);
    tmp[SUBJECTSIZE] = NULL;
    printf("Subject:  %-30s", tmp);

    memcpy(tmp, header_list[NoHead]->header.date, DATESIZE);
    tmp[DATESIZE] = NULL;
    printf("Date: %s ", tmp, header_list[NoHead]->header.time);

    memcpy(tmp, header_list[NoHead]->header.time, TIMESIZE);
    tmp[TIMESIZE] = NULL;
    printf("%s GMT\n", tmp);
    printf("--------------------------------------------------------------------------------\n");
/*
    if(header_list[NoHead]->header.size==1)
    	fprintf(outfile,"**EMPTY RECORD** %d\n",header_list[NoHead]->header.size);
    else
    	for(i=1;i<header_list[NoHead]->header.size;i++){
    	    if(read(infile,buf,RECSIZE)==-1)
    	    	return(0);
    	    printrec(buf,outfile);
    	}*/	/* print the body of the message, starts at 1 because 0
    			   is the header_list[NoHead]->header */


}
